Index: django/db/backends/__init__.py
===================================================================
--- django/db/backends/__init__.py	(revision 17914)
+++ django/db/backends/__init__.py	(working copy)
@@ -7,7 +7,7 @@
 from contextlib import contextmanager
 
 from django.conf import settings
-from django.db import DEFAULT_DB_ALIAS
+from django.db import DEFAULT_DB_ALIAS, QName
 from django.db.backends import util
 from django.db.transaction import TransactionManagementError
 from django.utils.importlib import import_module
@@ -44,7 +44,18 @@
 
     def __ne__(self, other):
         return not self == other
+    
+    def _get_schema(self):
+        return self.settings_dict['SCHEMA']
+    schema = property(_get_schema)
 
+    def _get_test_schema_prefix(self):
+        return self.settings_dict['TEST_SCHEMA_PREFIX']
+    test_schema_prefix = property(_get_test_schema_prefix)
+
+    def convert_schema(self, schema):
+        return schema or self.schema
+
     def _commit(self):
         if self.connection is not None:
             return self.connection.commit()
@@ -311,6 +322,13 @@
     def make_debug_cursor(self, cursor):
         return util.CursorDebugWrapper(cursor, self)
 
+    def qname(self, model):
+        """
+        Given a model class or instance, returns its current database table
+        name in schema qualified format.
+        """
+        return self.ops.qualified_name(model._meta.qualified_name)
+
 class BaseDatabaseFeatures(object):
     allows_group_by_pk = False
     # True if django.db.backend.utils.typecast_timestamp is used on values
@@ -404,11 +422,17 @@
     _confirmed = False
     supports_transactions = None
     supports_stddev = None
+    supports_foreign_keys = True
     can_introspect_foreign_keys = None
 
     # Support for the DISTINCT ON clause
     can_distinct_on_fields = False
 
+    # If the database has databases and schemas as different concepts
+    # or plain fakes schemas, it is safe to skip conflicts checking in
+    # testing on that database.
+    namespaced_schemas = False
+
     def __init__(self, connection):
         self.connection = connection
 
@@ -461,7 +485,7 @@
         self.connection = connection
         self._cache = None
 
-    def autoinc_sql(self, table, column):
+    def autoinc_sql(self, qualified_name, column):
         """
         Returns any SQL needed to support auto-incrementing primary keys, or
         None if no SQL is necessary.
@@ -513,7 +537,7 @@
         """
         return "DROP CONSTRAINT"
 
-    def drop_sequence_sql(self, table):
+    def drop_sequence_sql(self, qualified_name):
         """
         Returns any SQL necessary to drop the sequence for the given table.
         Returns None if no SQL is necessary.
@@ -594,7 +618,7 @@
 
         return smart_unicode(sql) % u_params
 
-    def last_insert_id(self, cursor, table_name, pk_name):
+    def last_insert_id(self, cursor, qualified_name, pk_name):
         """
         Given a cursor object that has just performed an INSERT statement into
         a table that has an auto-incrementing ID, returns the newly created ID.
@@ -673,6 +697,20 @@
         """
         raise NotImplementedError()
 
+    def qualified_name(self, qualified_name, from_model=False):
+        """
+        Formats the given schema, table_name tuple into database's
+        qualified and quoted name format. The schema can be None.
+
+        We need to know if the name if from an existing database
+        table, or from a model. The reason is that some backends
+        do modifications to the name (schema-prefix the table name)
+        at runtime, and we must not do that repeatedly. Hence, if
+        the name comes from the DB and is already schema-prefixed,
+        then we must not schema-prefix it again.
+        """
+        raise NotImplementedError
+
     def random_function_sql(self):
         """
         Returns a SQL expression that returns a random value.
@@ -718,7 +756,7 @@
         """
         return ''
 
-    def sql_flush(self, style, tables, sequences):
+    def sql_flush(self, style, tables, sequences, from_db):
         """
         Returns a list of SQL statements required to remove all data from
         the given database tables (without actually removing the tables
@@ -726,6 +764,9 @@
 
         The `style` argument is a Style object as returned by either
         color_style() or no_style() in django.core.management.color.
+
+        The from_db argument tells if the names are coming from database
+        or from model._meta, needed for schema support.
         """
         raise NotImplementedError()
 
@@ -883,25 +924,88 @@
         distinguish between a FloatField and IntegerField, for example."""
         return self.data_types_reverse[data_type]
 
-    def table_name_converter(self, name):
-        """Apply a conversion to the name for the purposes of comparison.
+    def qname_converter(self, qname, force_schema=False):
+        """
+        Apply a conversion to the name for the purposes of comparison.
 
         The default table name converter is for case sensitive comparison.
+
+        The given name must be a QName. If force_schema is set, then backends
+        should try to append a default schema name to the given name if
+        applicable for the backend.
         """
-        return name
+        return qname
 
+    def identifier_converter(self, identifier):
+        """
+        On some backends we need to do a little acrobaty to convert the names
+        from the DB and names from Models into consistent format. For example,
+        the return types from DB might be upper-case, but we need them
+        lower-case for comparisons. This method can be used to convert
+        identifiers into consistent format.
+        """
+        return identifier
+
+
     def table_names(self):
-        "Returns a list of names of all tables that exist in the database."
+        "Returns a list of names of all tables that are visible in the database."
         cursor = self.connection.cursor()
-        return self.get_table_list(cursor)
+        return self.get_visible_tables_list(cursor)
 
+    def get_visible_tables_list(self, cursoe):
+        """
+        Returns all visible (in "search path") tables from the database.
+        """
+        return []
+
+    def qualified_names(self, schemas=None):
+        """
+        Returns qualified table names for all schemas Django is using.
+        """
+        cursor = self.connection.cursor()
+        if schemas is None:
+            return self.get_visible_tables_list(cursor)
+        else:
+            return 
+        
+    def all_qualified_names(self):
+        """
+        Gets all table names from the database. Note that it is intentional
+        that visible tables appear both as unqualified and qualified tables.
+        """
+        cursor = self.connection.cursor()
+        nonqualified_tables = self.get_visible_tables_list(cursor)
+        schemas = self.connection.creation.get_schemas()
+        schemas = [self.connection.convert_schema(s) for s in schemas]
+        qualified_tables = self.get_qualified_tables_list(cursor, schemas)
+        return set([QName(None, t, from_db) for _, t, from_db
+                    in nonqualified_tables]
+                   + qualified_tables)
+    
+    def get_qualified_tables_list(self, cursor, schemas):
+        """
+        Returns schema qualified names (as pair schema, tbl_name) of all
+        tables in the given schemas.
+        """
+        return []
+
+    def get_schema_list(self, cursor):
+        "Returns a list of schemas that exist in the database"
+        return []
+    
+
+    def schema_names(self):
+        "Returns a list of schemas that exist in the database"
+        cursor = self.connection.cursor()
+        return self.get_schema_list(cursor)
+
     def django_table_names(self, only_existing=False):
         """
-        Returns a list of all table names that have associated Django models and
-        are in INSTALLED_APPS.
+        Returns a list of all table's qualified names that have associated
+        Django models and are in INSTALLED_APPS.
 
-        If only_existing is True, the resulting list will only include the tables
-        that actually exist in the database.
+        If only_existing is True, the resulting list will only include the
+        tables that actually exist in the database.
         """
         from django.db import models, router
         tables = set()
@@ -911,34 +1015,43 @@
                     continue
                 if not router.allow_syncdb(self.connection.alias, model):
                     continue
-                tables.add(model._meta.db_table)
-                tables.update([f.m2m_db_table() for f in model._meta.local_many_to_many])
+                tables.add(model._meta.qualified_name)
+                tables.update([f.m2m_qualified_name()
+                               for f in model._meta.local_many_to_many])
         tables = list(tables)
         if only_existing:
-            existing_tables = self.table_names()
-            tables = [
-                t
-                for t in tables
-                if self.table_name_converter(t) in existing_tables
-            ]
-        return tables
+            found_tables = []
+            existing_tables = self.all_qualified_names()
+            found_tables.extend([
+                t for t in tables
+                if self.qname_converter(t) in existing_tables
+            ])
+            return found_tables
+        else:
+            return tables
 
     def installed_models(self, tables):
-        "Returns a set of all models represented by the provided list of table names."
+        """
+        Returns a set of all models represented by the provided list of table names.
+
+        The given tables are assumed to be pre-converted.
+        """
         from django.db import models, router
         all_models = []
         for app in models.get_apps():
             for model in models.get_models(app):
                 if router.allow_syncdb(self.connection.alias, model):
                     all_models.append(model)
-        tables = map(self.table_name_converter, tables)
         return set([
             m for m in all_models
-            if self.table_name_converter(m._meta.db_table) in tables
+            if self.qname_converter(m._meta.qualified_name) in tables
         ])
 
     def sequence_list(self):
-        "Returns a list of information about all DB sequences for all models in all apps."
+        """
+        Returns a list of information about all DB sequences for all models
+        in all apps.
+        """
         from django.db import models, router
 
         apps = models.get_apps()
@@ -952,14 +1065,17 @@
                     continue
                 for f in model._meta.local_fields:
                     if isinstance(f, models.AutoField):
-                        sequence_list.append({'table': model._meta.db_table, 'column': f.column})
+                        qname = self.qname_converter(model._meta.qualified_name)
+                        sequence_list.append({'qname': qname, 'column': f.column})
                         break # Only one AutoField is allowed per model, so don't bother continuing.
 
                 for f in model._meta.local_many_to_many:
                     # If this is an m2m using an intermediate table,
                     # we don't need to reset the sequence.
                     if f.rel.through is None:
-                        sequence_list.append({'table': f.m2m_db_table(), 'column': None})
+                        qname = self.qname_converter(f.m2m_qualified_name())
+                        sequence_list.append({'qname': qname,
+                                              'column': None})
 
         return sequence_list
 
Index: django/core/management/commands/syncdb.py
===================================================================
--- django/core/management/commands/syncdb.py	(revision 17914)
+++ django/core/management/commands/syncdb.py	(working copy)
@@ -55,9 +55,14 @@
         db = options.get('database')
         connection = connections[db]
         cursor = connection.cursor()
-
+        converter = connection.introspection.qname_converter
+        # We might fetch the same table multiple times - once as qualified and
+        # once as visible table (None, t). That is wanted, so that we can easily
+        # see if a model with schema = None is installed, as well as if model with
+        # locked schema is installed.
+        tables = connection.introspection.all_qualified_names()
+        
         # Get a list of already installed *models* so that references work right.
-        tables = connection.introspection.table_names()
         seen_models = connection.introspection.installed_models(tables)
         created_models = set()
         pending_references = {}
@@ -71,9 +76,8 @@
         ]
         def model_installed(model):
             opts = model._meta
-            converter = connection.introspection.table_name_converter
-            return not ((converter(opts.db_table) in tables) or
-                (opts.auto_created and converter(opts.auto_created._meta.db_table) in tables))
+            return not ((converter(opts.qualified_name) in tables) or
+                (opts.auto_created and converter(opts.auto_created._meta.qualified_name) in tables))
 
         manifest = SortedDict(
             (app_name, filter(model_installed, model_list))
@@ -83,30 +87,57 @@
         # Create the tables for each model
         if verbosity >= 1:
             print "Creating tables ..."
+        seen_schemas = connection.introspection.schema_names()
+        seen_schemas = set([connection.introspection.identifier_converter(s)
+                            for s in seen_schemas])
+
         for app_name, model_list in manifest.items():
             for model in model_list:
                 # Create the model's database table, if it doesn't already exist.
                 if verbosity >= 3:
                     print "Processing %s.%s model" % (app_name, model._meta.object_name)
-                sql, references = connection.creation.sql_create_model(model, self.style, seen_models)
+                sql = []
+                schema = connection.convert_schema(model._meta.qualified_name[0])
+                if schema and schema not in seen_schemas:
+                    q = connection.creation.sql_create_schema(schema, self.style)
+                    if q:
+                        sql.append(q)
+                    seen_schemas.add(schema)
+                table_sql, references = connection.creation.sql_create_model(model, self.style, seen_models)
+                sql.extend(table_sql)
                 seen_models.add(model)
                 created_models.add(model)
                 for refto, refs in references.items():
                     pending_references.setdefault(refto, []).extend(refs)
                     if refto in seen_models:
-                        sql.extend(connection.creation.sql_for_pending_references(refto, self.style, pending_references))
-                sql.extend(connection.creation.sql_for_pending_references(model, self.style, pending_references))
+                        ref_sql = connection.creation.sql_for_pending_references(
+                            refto, self.style, pending_references)
+                        if ref_sql:
+                            sql.extend(ref_sql)
+                ref_sql = sql.extend(connection.creation.sql_for_pending_references(
+                    model, self.style, pending_references))
+                if ref_sql:
+                    sql.extend(ref_sql)
                 if verbosity >= 1 and sql:
-                    print "Creating table %s" % model._meta.db_table
+                    if model._meta.db_schema:
+                        print "Creating table %s.%s" % model._meta.qualified_name
+                    else:
+                        print "Creating table %s" % model._meta.db_table
                 for statement in sql:
                     cursor.execute(statement)
-                tables.append(connection.introspection.table_name_converter(model._meta.db_table))
+                tables.add(connection.introspection.qname_converter(model._meta.qualified_name))
 
-
         transaction.commit_unless_managed(using=db)
+        # We need to see if there are still some pending references left: this
+        # is possible on backends where we must do cross-schema references
+        # using different connections (hence also outside the above
+        # transaction)
+        if pending_references:
+            # Pass the references to connection-specific handler.
+            connection.creation.post_create_pending_references(pending_references)
 
-        # Send the post_syncdb signal, so individual apps can do whatever they need
-        # to do at this point.
+        # Send the post_syncdb signal, so individual apps can do whatever they
+        # need to do at this point.
         emit_post_sync_signal(created_models, verbosity, interactive, db)
 
         # The connection may have been closed by a syncdb handler.
Index: django/core/management/commands/loaddata.py
===================================================================
--- django/core/management/commands/loaddata.py	(revision 17914)
+++ django/core/management/commands/loaddata.py	(working copy)
@@ -218,8 +218,8 @@
 
             # Since we disabled constraint checks, we must manually check for
             # any invalid keys that might have been added
-            table_names = [model._meta.db_table for model in models]
-            connection.check_constraints(table_names=table_names)
+            qualified_names = [model._meta.qualified_name for model in models]
+            connection.check_constraints(table_names=qualified_names)
 
         except (SystemExit, KeyboardInterrupt):
             raise
Index: django/core/management/validation.py
===================================================================
--- django/core/management/validation.py	(revision 17914)
+++ django/core/management/validation.py	(working copy)
@@ -19,7 +19,6 @@
     validates all models of all installed apps. Writes errors, if any, to outfile.
     Returns number of errors.
     """
-    from django.conf import settings
     from django.db import models, connection
     from django.db.models.loading import get_app_errors
     from django.db.models.fields.related import RelatedObject
@@ -32,7 +31,7 @@
 
     for cls in models.get_models(app):
         opts = cls._meta
-
+        
         # Do field-specific validation.
         for f in opts.local_fields:
             if f.name == 'id' and not f.primary_key and opts.pk.name == 'id':
Index: django/core/management/sql.py
===================================================================
--- django/core/management/sql.py	(revision 17914)
+++ django/core/management/sql.py	(working copy)
@@ -3,12 +3,11 @@
 
 from django.conf import settings
 from django.core.management.base import CommandError
-from django.db import models
+from django.db import models, QName
 from django.db.models import get_models
 
 def sql_create(app, style, connection):
     "Returns a list of the CREATE TABLE SQL statements for the given app."
-
     if connection.settings_dict['ENGINE'] == 'django.db.backends.dummy':
         # This must be the "dummy" database backend, which means the user
         # hasn't set ENGINE for the database.
@@ -23,11 +22,16 @@
     # we can be conservative).
     app_models = models.get_models(app, include_auto_created=True)
     final_output = []
-    tables = connection.introspection.table_names()
+    tables = connection.introspection.all_qualified_names()
     known_models = set([model for model in connection.introspection.installed_models(tables) if model not in app_models])
     pending_references = {}
 
     for model in app_models:
+        schema = connection.convert_schema(model._meta.db_schema)
+        if schema:
+            output = connection.creation.sql_create_schema(schema, style)
+            if output:
+                final_output.append(output)
         output, references = connection.creation.sql_create_model(model, style, known_models)
         final_output.extend(output)
         for refto, refs in references.items():
@@ -63,7 +67,7 @@
 
     # Figure out which tables already exist
     if cursor:
-        table_names = connection.introspection.get_table_list(cursor)
+        table_names = connection.introspection.all_qualified_names(converted=True)
     else:
         table_names = []
 
@@ -75,7 +79,7 @@
     references_to_delete = {}
     app_models = models.get_models(app, include_auto_created=True)
     for model in app_models:
-        if cursor and connection.introspection.table_name_converter(model._meta.db_table) in table_names:
+        if cursor and connection.introspection.qname_converter(model._meta.qualified_name) in table_names:
             # The table exists, so it needs to be dropped
             opts = model._meta
             for f in opts.local_fields:
@@ -85,7 +89,7 @@
             to_delete.add(model)
 
     for model in app_models:
-        if connection.introspection.table_name_converter(model._meta.db_table) in table_names:
+        if connection.introspection.qname_converter(model._meta.qualified_name) in table_names:
             output.extend(connection.creation.sql_destroy_model(model, references_to_delete, style))
 
     # Close database connection explicitly, in case this output is being piped
@@ -106,7 +110,9 @@
     if only_django:
         tables = connection.introspection.django_table_names(only_existing=True)
     else:
-        tables = connection.introspection.table_names()
+        tables = connection.introspection.all_qualified_names()
+    if [t for t in tables if not isinstance(t, QName)]:
+        import ipdb; ipdb.set_trace()
     statements = connection.ops.sql_flush(
         style, tables, connection.introspection.sequence_list()
     )
@@ -145,7 +151,7 @@
     if opts.managed:
         post_sql_fields = [f for f in opts.local_fields if hasattr(f, 'post_create_sql')]
         for f in post_sql_fields:
-            output.extend(f.post_create_sql(style, model._meta.db_table))
+            output.extend(f.post_create_sql(style, model._meta.qualified_name))
 
     # Some backends can't execute more than one SQL statement at a time,
     # so split into separate statements.
Index: django/contrib/contenttypes/generic.py
===================================================================
--- django/contrib/contenttypes/generic.py	(revision 17914)
+++ django/contrib/contenttypes/generic.py	(working copy)
@@ -173,6 +173,12 @@
     def m2m_db_table(self):
         return self.rel.to._meta.db_table
 
+    def m2m_qualified_name(self):
+        return self.rel.to._meta.qualified_name
+
+    def m2m_db_schema(self):
+        return self.rel.to._meta.db_schema
+
     def m2m_column_name(self):
         return self.object_id_field_name
 
Index: django/test/simple.py
===================================================================
--- django/test/simple.py	(revision 17914)
+++ django/test/simple.py	(working copy)
@@ -271,6 +271,8 @@
         dependencies = {}
         for alias in connections:
             connection = connections[alias]
+            if not connection.settings_dict['TEST_SCHEMA_PREFIX'] is None:
+                connection.settings_dict['TEST_SCHEMA_PREFIX'] = '%s_' % alias
             if connection.settings_dict['TEST_MIRROR']:
                 # If the database is marked as a test mirror, save
                 # the alias.
@@ -301,20 +303,20 @@
             test_databases.items(), dependencies):
             # Actually create the database for the first connection
             connection = connections[aliases[0]]
-            old_names.append((connection, db_name, True))
-            test_db_name = connection.creation.create_test_db(
+            test_db_name, created_schemas = connection.creation.create_test_db(
                 self.verbosity, autoclobber=not self.interactive)
+            old_names.append((connection, db_name, True, created_schemas))
             for alias in aliases[1:]:
                 connection = connections[alias]
                 if db_name:
-                    old_names.append((connection, db_name, False))
+                    old_names.append((connection, db_name, False, []))
                     connection.settings_dict['NAME'] = test_db_name
                 else:
                     # If settings_dict['NAME'] isn't defined, we have a backend
                     # where the name isn't important -- e.g., SQLite, which
                     # uses :memory:. Force create the database instead of
                     # assuming it's a duplicate.
-                    old_names.append((connection, db_name, True))
+                    old_names.append((connection, db_name, True, []))
                     connection.creation.create_test_db(
                         self.verbosity, autoclobber=not self.interactive)
 
@@ -335,9 +337,9 @@
         Destroys all the non-mirror databases.
         """
         old_names, mirrors = old_config
-        for connection, old_name, destroy in old_names:
+        for connection, old_name, destroy, created_schemas in old_names:
             if destroy:
-                connection.creation.destroy_test_db(old_name, self.verbosity)
+                connection.creation.destroy_test_db(old_name, created_schemas, self.verbosity)
 
     def teardown_test_environment(self, **kwargs):
         unittest.removeHandler()
